'use strict';

var _Location = require('../Location');

var _sinon = require('sinon');

describe('GeoLocation', function () {
  it('should accept geoOptions', function () {
    var wrapper = mount(React.createElement(_Location.GeoLocation, {
      timeout: null,
      maximumAge: null,
      enableHighAccuracy: null
    }));

    var instance = wrapper.instance();

    var options = instance.geoOptions;
    expect(options).toEqual({});
  });

  it('should accept geoOptions and return an object with 3 props', function () {
    var wrapper = mount(React.createElement(_Location.GeoLocation, {
      timeout: 36000,
      maximumAge: 10000,
      enableHighAccuracy: true
    }));

    var instance = wrapper.instance();

    var options = instance.geoOptions;
    expect(options).toEqual({
      enableHighAccuracy: true,
      timeout: 36000,
      maximumAge: 10000
    });
  });

  it('should call the watch the location fn', function () {
    var wrapper = mount(React.createElement(_Location.GeoLocation, {
      watch: true
    }));

    var instance = wrapper.instance();
    var watchFn = instance.watchGeoLocation = (0, _sinon.spy)();
    instance.componentWillMount();
    expect(watchFn.calledOnce).toEqual(true);
  });

  it('should call the getLocation fn', function () {
    var wrapper = mount(React.createElement(_Location.GeoLocation, null));

    var instance = wrapper.instance();
    var locationFn = instance.getLocation = (0, _sinon.spy)();
    instance.componentWillMount();
    expect(locationFn.calledOnce).toEqual(true);
  });
});